#!/bin/bash

declare -a test_commands=("/opt/appbin/hugo version" 
			  "antora --version" 
			  "decktape version" 
			  "chromium-browser --version" 
			  "asciidoctor --version" 
			  "asciidoctor-revealjs --version" 
			  "asciidoctor-pdf --version")

function run_test () {
	cmd="$1"
	echo [-] Running command: $cmd
	$cmd && echo [+] Succesfully ran previous command || errors="$errors\n  Error running the command: $cmd"
	echo ""
}
errors=""
for entry in "${test_commands[@]}"
do
	run_test "$entry"
done
if [ ! -z "$errors" ]; then
	printf "[!] There were errors: $errors\n"
	exit 1
fi
